ape-releasing
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![Dependency Status][bd_gemnasium_shield_url]][bd_gemnasium_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]
[![JS Standard][bd_standard_shield_url]][bd_standard_url]

[bd_repo_url]: https://github.com/ape-repo/ape-releasing
[bd_travis_url]: http://travis-ci.org/ape-repo/ape-releasing
[bd_travis_shield_url]: http://img.shields.io/travis/ape-repo/ape-releasing.svg?style=flat
[bd_travis_com_url]: http://travis-ci.com/ape-repo/ape-releasing
[bd_travis_com_shield_url]: https://api.travis-ci.com/ape-repo/ape-releasing.svg?token=
[bd_license_url]: https://github.com/ape-repo/ape-releasing/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/ape-repo/ape-releasing
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/ape-repo/ape-releasing.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/ape-repo/ape-releasing.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/ape-repo/ape-releasing
[bd_gemnasium_shield_url]: https://gemnasium.com/ape-repo/ape-releasing.svg
[bd_npm_url]: http://www.npmjs.org/package/ape-releasing
[bd_npm_shield_url]: http://img.shields.io/npm/v/ape-releasing.svg?style=flat
[bd_standard_url]: http://standardjs.com/
[bd_standard_shield_url]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

ape framework module for releasing tasks.

<!-- Description End -->




<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>

Usage
----

### Release a npm Package

`.apeReleasing.releasePackage()` function will do:

1. Create a git tag and push to remote.
2. Publish package to npm.
3. Increment package.json version number.
4. Commit and push git local changes.

```javascript
#!/usr/bin/env node
'use strict'

const apeReleasing = require('ape-releasing')

// Release a npm package
apeReleasing.releasePackage({
  beforeRelease: [ // Scripts run before releasing
    './ci/build.js',
    './ci/test.js'
  ]
}).then(() => {
  /* ... */
})

```



<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.Options.md.hbs" Start -->

<a name="section-doc-guides-03-options-md"></a>

Options
-------

Available options for `.releasePackage(options, callback)` method.

| Name | Type | Value |
| ---- | ----- | ----- |
| beforeRelease | function[] | Tasks to do before release |
| afterRelease | function[] | Tasks to do after release |
| skipInteractive | boolean | Skip confirming before releasing. |



<!-- Section from "doc/guides/03.Options.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/ape-repo/ape-releasing/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [ape-repo][ape_repo_url]
+ [npm][npm_url]

[ape_repo_url]: https://github.com/ape-repo
[npm_url]: https://www.npmjs.com/

<!-- Links End -->
